// coin macro
#macro coin(coin_rad,an,coin_pig,coin_norm,coin_fin,hf_coin,hf_coin_back)

#local cp=coin_pig;
#local t_metal=
texture{
 pigment{rgb coin_pig}
 normal{coin_norm}
 finish{F_MetalC reflection{cp*.5,cp*.75}}
 scale coin_rad*2
}

#if (use_rad=2)
cylinder{<0,-an*.5,0>,<0,an*.5,0>,coin_rad
  texture{pigment{rgb coin_pig}}
}
#else
union{
 // border
 union{
  #declare icb=0;
  #declare ncb=pi*coin_rad/(an*.125);
  #while (icb<ncb)
  cylinder{-an*.5*y,an*.5*y,an*.125
   translate -coin_rad*.97*z
   rotate (360*icb/ncb)*y
  }
  #declare icb=icb+1;
  #end
  texture{t_metal}
 }
 // face & back
 union{
  object{hf_coin scale <coin_rad*1.94,an,coin_rad*1.94>}
  object{hf_coin_back scale <coin_rad*1.94,an,coin_rad*1.94> rotate 180*x}
  texture{t_metal}
 }
}

#end

#end // macro coin


// *** stack of coins macro ***
#macro coins_stack(coin_obj,coin_thick,num_coins,stack_seed)
#local r_stack=seed(stack_seed);
#local i_coins=0;
union{
 #while (i_coins<num_coins)
  object{coin_obj
   #if (rand(r_stack)>.5)
   rotate 180*x
   #end
   rotate 360*rand(r_stack)*y 
   translate <-coin_thick+coin_thick*2*rand(r_stack),(coin_thick*1.25)*i_coins,-coin_thick+coin_thick*2*rand(r_stack)>
  }
  #local i_coins=i_coins+1;
 #end
 rotate 360*rand(r_stack)*y
}
#end // macro coins_stack
